/////////////////////////////////////////////////////////////////////////////
// chem2D Editor
// This class is based on QCanvasView.
// 2D molecule editor
// (c) Copyleft 2000, by Ricardo Stefani
/////////////////////////////////////////////////////////////////////////////

#ifndef __CHEMEDITOR_H__
#define __CHEMEDITOR_H__


#include <qcanvas.h>
#include <qworkspace.h>
#include <qpopupmenu.h>
#include "chemdefs.h"


class chem2DEditor: public QCanvasView
{
        Q_OBJECT
private:
 QCanvas* cv;
 QPopupMenu* menuProperties;

 bool drawing;
 void SelectItem(QMouseEvent* ev);
 void ProcessPopup(QMouseEvent* ev);
 void DrawBond(QMouseEvent* ev);
 void DrawAtom(QMouseEvent* ev);
 void DrawCicle(QMouseEvent* ev);
 void DrawAromatic(QMouseEvent* ev);
 void DrawCpentane(QMouseEvent* ev);
 void DrawSbunder(QMouseEvent* ev);
 void DrawSbhigh(QMouseEvent* ev);
protected:
  QCanvasItem *ActualItem;
  QPoint start;
  void contentsMousePressEvent(QMouseEvent* ev);
  void contentsMouseMoveEvent(QMouseEvent* ev);
  void contentsMouseReleaseEvent(QMouseEvent* ev);
  void contentsMouseDoubleClickEvent(QMouseEvent* ev);

public slots:
  void setPen(); // change the color of Selected Item
  void setFont(); // change the font of Atom Text

public:
  TOOL Selected;
  QCanvas* getCanvas() { return cv; };
  chem2DEditor(QCanvas* v = 0 , QWidget* parent = 0,
                    const char *name = 0, WFlags f = 0);
  ~chem2DEditor();

};


#endif
