///////////////////////////////////////////////////////////////////////////
// chemaromatic.cpp
///////////////////////////////////////////////////////////////////////////

#include "chemaromatic.h"

chemAromatic::chemAromatic(QCanvas* canvas) :
    QCanvasPolygonalItem(canvas)
{
}

chemAromatic::~chemAromatic()
{
    hide();
}

void chemAromatic::drawShape(QPainter & p)
{
    p.drawPolygon(pa);
    p.drawLine(pa[4].x() - 4, pa[4].y() + 2,
               pa[5].x() - 4, pa[5].y() - 2);
    p.drawLine(pa[2].x() + 4, pa[2].y() + 2,
               pa[3].x() - 2, pa[3].y() + 5);
    p.drawLine(pa[0].x() - 2, pa[0].y() - 5,
               pa[1].x() + 4, pa[1].y() - 2);

}

void chemAromatic::setPoints(QPointArray points)
{
    pa = points;
    pa.translate((int)x(),(int)y());
}

void chemAromatic::moveBy(double dx, double dy)
{
    int idx = int(x()+dx)-int(x());
    int idy = int(y()+dy)-int(y());
    if ( idx || idy ) {
        hide();
        pa.translate(idx,idy);
	QCanvasItem::moveBy(dx,dy);
        show();
    }
}


QPointArray chemAromatic::points() const
{
    QPointArray pa1 = areaPoints();
    pa1.translate(int(-x()),int(-y()));
    return pa1;
}

QPointArray chemAromatic::areaPoints() const
{
    return pa;
}
