////////////////////////////////////////////////////////////////////////////
// chem2D
// Polygon for aromatics cicle
///////////////////////////////////////////////////////////////////////////

#ifndef __CHEM_AROMATIC_H
#define __CHEM_AROMATIC_H


#include <qcanvas.h>
#include <qpointarray.h>
#include "chemdefs.h"

#define aromaticRTTI chemistryRTTI + 2

class chemAromatic: public QCanvasPolygonalItem
{
private:
   QPointArray pa;
protected:
   virtual void drawShape(QPainter& p);
   virtual QPointArray areaPoints() const;
public:
   QPointArray points() const;
   chemAromatic(QCanvas* canvas);
   ~chemAromatic();
   void setPoints(QPointArray points);
   void moveBy(double dx, double dy);
   int rtti() const { return aromaticRTTI; } ;
};



#endif
