////////////////////////////////////////////////////////////////////////////
// chem2D
// Polygon for Bond Lines
///////////////////////////////////////////////////////////////////////////

#ifndef __CHEM_BOND_H
#define __CHEM_BOND_H


#include <qcanvas.h>
#include <qpointarray.h>
#include "chemdefs.h"

#define bondRTTI chemistryRTTI + 11

class chemBond: public QCanvasPolygonalItem
{
private:
   int x1, x2, y1, y2;
   QPointArray pp; // UPLA and HPLA
   BondStyle style;
protected:
   virtual void drawShape(QPainter& p);
   virtual QPointArray areaPoints() const;
public:
   QPointArray points() const;
   QPoint startPoint() { return(QPoint(x1, y1)); };
   QPoint endPoint() { return(QPoint(x2, y2)); };
   chemBond(QCanvas* canvas);
   chemBond(QCanvas* canvas, BondStyle style);
   ~chemBond();
   void setPoints(int x1, int y1, int x2, int y2);
   void moveBy(double dx, double dy);
   BondStyle getNextstyle();
   BondStyle getStyle() { return style; };
   void setStyle(BondStyle style)
   { this->style = style;
     hide();
     show();
   };
   int rtti() const { return bondRTTI; } ;
};



#endif
