///////////////////////////////////////////////////////////////////////////
// chemhexane.cpp
///////////////////////////////////////////////////////////////////////////

#include "chemcpentane.h"
#include <qwmatrix.h>

chemCpentane::chemCpentane(QCanvas* canvas) :
    QCanvasPolygonalItem(canvas)
{
}

chemCpentane::~chemCpentane()
{
    hide();
}

void chemCpentane::drawShape(QPainter & p)
{
    p.drawPolygon(pa);
}

void chemCpentane::setPoints(QPointArray points)
{
    pa = points;
    pa.translate((int)x(),(int)y());
}

void chemCpentane::moveBy(double dx, double dy)
{
    int idx = int(x()+dx)-int(x());
    int idy = int(y()+dy)-int(y());
    if ( idx || idy ) {
        hide();
        pa.translate(idx,idy);
	QCanvasItem::moveBy(dx,dy);
        show();
    }
}


QPointArray chemCpentane::points() const
{
    QPointArray pa1 = areaPoints();
    pa1.translate(int(-x()),int(-y()));
    return pa1;
}

QPointArray chemCpentane::areaPoints() const
{
    return pa;
}
