////////////////////////////////////////////////////////////////////////////
// chem2D
// Polygon for c5h10
///////////////////////////////////////////////////////////////////////////

#ifndef __CHEM_CPENTANE_H
#define __CHEM_CPENTANE_H


#include <qcanvas.h>
#include <qpointarray.h>
#include "chemdefs.h"

#define cpentaneRTTI chemistryRTTI + 5

class chemCpentane: public QCanvasPolygonalItem
{
private:
   QPointArray pa;
protected:
   virtual void drawShape(QPainter& p);
   virtual QPointArray areaPoints() const;
public:
   QPointArray points() const;
   chemCpentane(QCanvas* canvas);
   ~chemCpentane();
   void setPoints(QPointArray points);
   void moveBy(double dx, double dy);
   int rtti() const { return cpentaneRTTI; } ;
};



#endif
