///////////////////////////////////////////////////////////////////////////
// chemHexane.cpp
///////////////////////////////////////////////////////////////////////////

#include "chemhexane.h"
#include <qnamespace.h>
#include <qfont.h>
#include <qrect.h>

#define REF 4

// caculate the center of text


QPoint calcCenter(QPainter& p, QString text)
{
  int w, h;
  
  QRect r = p.fontMetrics().boundingRect(text);
  w = r.right();
  h = r.bottom();
  qDebug("%d %d", w, h);
  return(QPoint((int) w/2, (int) h/2));
}


chemHexane::chemHexane(QCanvas* canvas) :
    QCanvasPolygonalItem(canvas)
{
}

chemHexane::~chemHexane()
{
    hide();
}

void chemHexane::drawShape(QPainter & p)
{
    p.drawPolygon(pa);
    if(!dbounds.isEmpty())
     {
       dbounds.first();
       for(int i=0;i<dbounds.count();i++)
        {
        DOUBLEBOUND* db = dbounds.at(i);
        p.drawLine(db->p[0], db->p[1]);
        dbounds.next();
        }
    }
}

void chemHexane::setPoints(QPointArray points)
{
    pa = points;
    pa.translate((int)x(),(int)y());
}

void chemHexane::moveBy(double dx, double dy)
{
    int idx = int(x()+dx)-int(x());
    int idy = int(y()+dy)-int(y());
    if ( idx || idy ) {
        hide();
        pa.translate(idx,idy);

        if(!dbounds.isEmpty())
         {
         dbounds.first();
         for(int i=0;i<dbounds.count();i++)
            {
            QPoint t;
            t = QPoint(dbounds.at(i)->p[0].x() + dx,
                       dbounds.at(i)->p[0].y() + dy);
            dbounds.at(i)->p[0] = t;
            t = QPoint(dbounds.at(i)->p[1].x() + dx,
                       dbounds.at(i)->p[1].y() + dy);
            dbounds.at(i)->p[1] = t;
            }
         }
        QCanvasItem::moveBy(dx,dy);
        show();
    }
}


QPointArray chemHexane::points() const
{
    QPointArray pa1 = areaPoints();
    pa1.translate(int(-x()),int(-y()));
    return pa1;
}

QPointArray chemHexane::areaPoints() const
{
    QPointArray px(6);
    px[0] = QPoint(pa[0].x(), pa[0].y() + 3);
    px[1] = QPoint(pa[1].x() - 3, pa[1].y());
    px[2] = QPoint(pa[2].x() - 3, pa[2].y());
    px[3] = QPoint(pa[3].x(), pa[3].y() - 3);
    px[4] = QPoint(pa[4].x() + 3, pa[4].y());
    px[5] = QPoint(pa[5].x() + 3, pa[5].y());
    return px;
}

void chemHexane::addHetero(QString symbol, int pos)
{
ATOM *atm = new ATOM;
atm->pos = pos;
atm->symbol = symbol;
hetero.append(atm);
}

void chemHexane::changeOrder(QPoint p1, QPoint p2)
{
DOUBLEBOUND* db = new DOUBLEBOUND;
db->p[0] = p1;
db->p[1] = p2;
// check if double bound exists, if not add else delete it
//if(dbounds.find(db))
//  dbounds.remove(); else
  dbounds.append(db);

}
