////////////////////////////////////////////////////////////////////////////
// chem2D
// Polygon for aromatics cicle
///////////////////////////////////////////////////////////////////////////

#ifndef __CHEM_HEXANE_H
#define __CHEM_HEXANE_H


#include <qcanvas.h>
#include <qpointarray.h>
#include <qlist.h>
#include "chemdefs.h"

#define hexaneRTTI chemistryRTTI + 1

typedef struct _doublebound
{
QPointArray p;
_doublebound::_doublebound()
 { p = QPointArray(2); };
} DOUBLEBOUND;

class chemHexane: public QCanvasPolygonalItem
{
private:
   QList<ATOM> hetero;
   QList<DOUBLEBOUND> dbounds;
   QPointArray pa;
protected:
   virtual void drawShape(QPainter& p);
   virtual QPointArray areaPoints() const;
public:
   QPointArray points() const;
   QPointArray realPoints() const { return pa; };
   chemHexane(QCanvas* canvas);
   ~chemHexane();
   void setPoints(QPointArray points);
   void moveBy(double dx, double dy);
   void addHetero(QString symbol, int pos = 0);
   void changeOrder(QPoint p1, QPoint p2);
   int rtti() const { return hexaneRTTI; } ;
};



#endif
