////////////////////////////////////////////////////////////////////////////
// spectrum.h
// (c) 2000-2001 chemsuite Project
// this program is released under GPL
// this class is a generic class for Infrared Spectra
//////////////////////////////////////////////////////////////////////////

#ifndef __SPECTRUM_H
#define __SPECTRUM_H

#include <qstring.h>
#include <qtextstream.h>
#include <qstringlist.h>
#include <stdio.h>

#define XLEN 450
#define YLEN 250
#define STARTX 50
#define STARTY 50
#define ENDX 500
#define ENDY 300

typedef enum
{
transmittance = 0,
absorbance = 1
} YUnits;

typedef enum
{
cmRecipro = 0,
other = 1
} XUnits;

typedef enum
{
tiNone = 0,
tiTitle = 1,
tiOrigin = 2,
tiOwner = 3,
tiXunits = 4,
tiYunits = 5,
tiNpoints = 6,
tiXfactor = 7,
tiYfactor = 8,
tiFirstX = 9,
tiLastX = 10,
tiFirstY = 11,
tiData = 12,
tiTime = 13,
tiDate = 14,
tiCreated = 15,
tiMinY = 16,
tiMaxY = 17

} TypeInfo;


class Spectrum
{
 public:
  bool Data;
  QString Title;
  QString Origin;
  QString Owner;
  QString Time;
  QString Date;
  QString Created;
  QString Spectrometer;
  XUnits xunits;
  YUnits yunits;
  float lastx;
  float firstx;
  float firsty;
  int Npoints;
  bool Valid;

  protected:
  FILE* f;
  
  QString linhaAtual; // Actual File Line
  QTextIStream* spectraFile;
  virtual void LoadData()=0;
  virtual void ProcessPoints()=0;
  virtual QString& GetValue()=0;
  virtual int GetType()=0;

 public:
   QString Afname;
   QStringList xValues;
   QStringList yValues;
   QStringList waveNumbers;
   QStringList transmitancia;
   int nPixelsX;
   bool needFill;
   float xFactor;
   float yFactor;
   float incFactor;
   float minY;
   float maxY;

   Spectrum(QString AFile);
   ~Spectrum();
   virtual void Load(QString AFile)=0;
   void ProcessSpectrum();
};

#endif
